%global with_ib 0

%{?filter_setup:
%filter_provides_in %{perl_vendorarch}/.*\.so$
%filter_setup
}

Summary:       Node up/down detection utility
Name:          whatsup
Version:       1.14.1
%global upstream_sf_version_main %(echo %{version} | rev | cut -d . -f 2- | rev)
%global upstream_sf_version_patch %(echo %{version} | rev | cut -d . -f 1 | rev)
Release:       1%{?dist}
License:       GPLv2+
URL:           https://github.com/chaos/whatsup
Source0:       http://downloads.sourceforge.net/project/%{name}/%{name}/%{upstream_sf_version_main}-%{upstream_sf_version_patch}/%{name}-%{upstream_sf_version_main}.tar.gz
Source1:       %{name}-hostsfile
Source2:       %{name}-pingd.service
Patch3000:     whatsup-1.14-bug#1117251.patch
Patch3001:     whatsup-1.14-Adjust-to-Autoconf-2.71.patch

BuildRequires: make, libtool-ltdl-devel, libgenders-devel, expat-devel, autoconf, automake, libtool, systemd-units, ganglia-devel
BuildRequires: perl-devel, perl-generators, perl(ExtUtils::MakeMaker)

Requires:      libnodeupdown = %{version}-%{release}

%description
Whatsup is a cluster node up/down detection utility.

Whatsup can quickly calculate and output the up and down nodes of a cluster.
Whatsup allows some tools, such as Pdsh, to operate more quickly by
not operating on down nodes. Whatsup calculates the up and down nodes of a
cluster through one of several possible backend tools
and several optional cluster node databases.

%package -n    libnodeupdown-devel
Summary:       Development headers for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}

%description -n libnodeupdown-devel
development headers for libnodeupdown

%package -n    libnodeupdown
Summary:       A cluster node up/down detection library

%description -n libnodeupdown
A cluster node up/down detection library, with different backends

%package -n    libnodeupdown-backend-ganglia
Summary:       Ganglia backend for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}

%description -n libnodeupdown-backend-ganglia
Ganglia backend module for libnodeupdown

%if %{with_ib}
%package -n    libnodeupdown-backend-openib
Summary:       Openib backend for libnodeupdown
BuildRequires: opensm-devel, libibcommon-devel, rdma-core-devel
Requires:      libnodeupdown = %{version}-%{release}

%description -n libnodeupdown-backend-openib
openib backend module for libnodeupdown
%endif

%package -n    libnodeupdown-backend-pingd
Summary:       Pingd backend for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}
Requires:      %{name}-pingd = %{version}-%{release}

%description -n libnodeupdown-backend-pingd
pingd backend module for libnodeupdown

%package -n    %{name}-pingd
Summary:       Pingd daemon for %{name}
Requires:      libnodeupdown = %{version}-%{release}
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

%description -n %{name}-pingd
pingd daemon for %{name}

%package -n    perl-libnodeupdown
Summary:       Perl bindings for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}

%description -n perl-libnodeupdown
Perl bindings for libnodeupdown

%package -n    libnodeupdown-clusterlist-hostsfile
Summary:       Hostsfile clusterlist module for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}

%description -n libnodeupdown-clusterlist-hostsfile
Hostsfile clusterlist module for libnodeupdown

%package -n    libnodeupdown-clusterlist-genders
Summary:       Genders clusterlist module for libnodeupdown
Requires:      libnodeupdown = %{version}-%{release}

%description -n libnodeupdown-clusterlist-genders
Genders clusterlist module for libnodeupdown



%prep
%setup -q -n %{name}-%{upstream_sf_version_main}
%patch3000 -p0
%patch3001 -p1



%build
autoreconf -I config -f -i

%configure \
    --disable-static \
    --with-perl-extensions \
    --with-perl-vendor-arch \
    --with-perl-destdir="%{buildroot}"

%{make_build}



%install
%{make_install}

mkdir -vp %{buildroot}%{_unitdir}
install -m 644 -p %{SOURCE2} %{buildroot}%{_unitdir}/
rm -rf %{buildroot}%{_initrddir}

chmod -x %{buildroot}%{_sysconfdir}/nodeupdown.conf
chmod -x %{buildroot}%{_sysconfdir}/pingd.conf

install -m 644 -p %{SOURCE1} %{buildroot}%{_sysconfdir}/hostsfile

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -type f -name "*.bs" -exec rm -f {} \;
find %{buildroot} -type f -name "*.la" -exec rm -f {} \;

%{_fixperms} %{buildroot}/*
touch %{buildroot}%{_sysconfdir}/hostsfile



%post -n libnodeupdown -p /sbin/ldconfig
%postun -n libnodeupdown -p /sbin/ldconfig

%post -n %{name}-pingd
%systemd_post whatsup-pingd.service

%preun -n %{name}-pingd
%systemd_preun whatsup-pingd.service

%postun -n %{name}-pingd
%systemd_postun_with_restart whatsup-pingd.service

%triggerun -n %{name}-pingd -- whatsup-pingd < 1.12-6
/usr/bin/systemd-sysv-convert --save whatsup-pingd >/dev/null 2>&1 ||:

/sbin/chkconfig --del whatsup-pingd >/dev/null 2>&1 || :
/bin/systemctl try-restart whatsup-pingd.service >/dev/null 2>&1 || :



%files
%license COPYING
%doc AUTHORS DISCLAIMER NEWS README ChangeLog
%{_bindir}/whatsdown
%{_bindir}/whatsup
%{_mandir}/man1/*

%files -n perl-libnodeupdown
%license COPYING
%{_mandir}/man3/Libnodeupdown.3*
%{_mandir}/man3/Nodeupdown.3*
%{perl_vendorarch}/*
%exclude %dir %{perl_vendorarch}/auto/

%files -n %{name}-pingd
%license COPYING
%{_sbindir}/pingd
%dir %{_libdir}/pingd
%{_libdir}/pingd/pingd_clusterlist_hostsfile.so
%{_libdir}/pingd/pingd_clusterlist_genders.so
%config(noreplace) %{_sysconfdir}/hostsfile
%{_unitdir}/%{name}-pingd.service
%{_mandir}/man5/pingd.conf.5*
%{_mandir}/man8/pingd.8*
%config(noreplace) %{_sysconfdir}/pingd.conf

%files -n libnodeupdown-devel
%license COPYING
%{_libdir}/libnodeupdown*.so
%{_includedir}/nodeupdown.h
%dir %{_includedir}/nodeupdown
%{_includedir}/nodeupdown/*.h
%{_mandir}/man3/nodeupdown*

%files -n libnodeupdown
%license COPYING
%{_libdir}/libnodeupdown*.so.*
%dir %{_libdir}/nodeupdown
%{_mandir}/man3/libnodeupdown.3*
%{_mandir}/man5/nodeupdown.conf.5*
%config(noreplace) %{_sysconfdir}/nodeupdown.conf

%files -n libnodeupdown-backend-ganglia
%license COPYING
%{_libdir}/nodeupdown/nodeupdown_backend_ganglia.so

%if %{with_ib}
%files -n libnodeupdown-backend-openib
%license COPYING
%{_libdir}/nodeupdown/nodeupdown_backend_openib.so
%endif

%files -n libnodeupdown-backend-pingd
%license COPYING
%{_libdir}/nodeupdown/nodeupdown_backend_pingd.so

%files -n libnodeupdown-clusterlist-genders
%license COPYING
%{_libdir}/nodeupdown/nodeupdown_clusterlist_genders.so

%files -n libnodeupdown-clusterlist-hostsfile
%license COPYING
%{_libdir}/nodeupdown/nodeupdown_clusterlist_hostsfile.so
%config(noreplace) %{_sysconfdir}/hostsfile



%changelog
* Tue Mar 12 2024 Zhao Zhen <jeremiazhao@tencent.com> - 1.14.1-1
- convert version from x.y-z to x.y.z

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Mar 29 2023 Zhao Zhen <jeremiazhao@tencent.com> - 1.14-1
- initial
